/*******************************************
ͺ:OLED-A 
MCU :89S52
:ʾ
д:MO
:2014/4/15
********************************************/

#include <reg52.h>
#include "pic1.h"
#include "pic.h"

#define uchar      unsigned char
#define uint       unsigned int

#define MHz     1000000U			//  MHz
#define gCLK    (11.0592*MHz)		// ϵͳʱƵ(22.1184*MHz)	 (11.0592*MHz) 
#define UART_BAUD   19200 			// õĲ
#define UART_BAUD_1200   1200 			// õĲ
sbit RST= 	P3^4;   //Reset Signal ͵ƽЧ

sbit LCD_BUSY=P3^2;  //H:յݲڴ,L:пɽ
/*
sbit CS=	P3^3;   //;
sbit RST= 	P3^4;   //Reset Signal ͵ƽЧ
sbit SDO=P3^2; 
sbit SDIN=P3^1;   
sbit SCLK=P3^0;  
*/
uchar X[4];
uchar RevTab[10];
char count=0;
void send_stop_word(void);
/**********nusʱӳ*************/
void Delay_Nus(uint n)
{
	while(n--);
}

/**********nmsʱӳ*************/
void Delay_Nms(uint n)
{
	uint i,j;
	for(i=0;i<n;i++)
		for(j=0;j<125;j++)
			;
}

/**********д*************/
void SendData(uchar content)
{  
	while(LCD_BUSY==1);	//æ
	SBUF = content;		// ݷ뻺
	while(TI==0);  		// ȴͻΪ
	TI=0;
	
  /*
	 uchar i;
	// chk_busy ();
	CS=0;
	for(i=0;i<8;i++)
	{
		content<<=1;
		SDIN=CY;
		SCLK=1;
		SCLK=0;
	}      
	CS=1;
	*/
}
/*****************UART*****************/
unsigned char USART_Receive( void )
{
	while(RI==0);
	RI=0;
  	return SBUF;
  	/*
	 uchar i;
	 uchar DataBuf=0;
	// chk_busy ();
	CS=0;
	for(i=0;i<8;i++)
	{
		DataBuf<<=1;
		if(SDO)
		{
			DataBuf|=0x01;
		}
		SCLK=1;
		SCLK=0;
	}      
	CS=1;
	
  	return DataBuf;
  	*/
}

/**********дݵLCD*************/
void SendDataToLCD(uchar cmd,uchar numh,uchar numl)
{
	SendData(0xfd);
	SendData(cmd);
	SendData(numh);
	SendData(numl);
}


/**************ʾص******************/
void Display_bit(void)
{
	uint i,k;
	SendDataToLCD(0x21,0,0);
	SendData(1);
	for(k=0;k<2;k++)
	{
		for(i=0;i<128;i++)
		{
			//SendData(i>>8);
			SendData(i);
			//SendData(k>>8);
			SendData(k);
		}
	} 
	send_stop_word();
}

/************ʾ*****************/
void Display_Chn(uchar const *chn,uchar Type,uchar Count)
{
	uchar i;
	
	SendDataToLCD(Type,0,0);
	SendData(0);
	SendData(0);
	SendData(0);
	SendData(0);

	for(i=0;i<Count;i++)
	{
		SendData(chn[i*2]);
		SendData(chn[i*2+1]);
	}
	send_stop_word();
}
uint strlen(char *string)
{
	uint len=0;
	while(*string++) len++;
	return len;
}
/************ʾģʽʾӦַ*****************/
void PutString(uint x,uint y,uchar mode,char *string)   
{
	uint len;
	len=strlen(string); 
	len=len+5;
	SendData(0xfd);
	SendData(mode);	
	SendData(len/256);
	SendData(len%256);
	
	SendData(x/256);
	SendData(x%256);
	SendData(y/256);
	SendData(y%256);
	
	while(*string != '\0')
	{
		SendData(*string);
		string++;
	}
	//UART0_SendByte('\0');

 	send_stop_word();
}

/***********************************/
//UART0 initialize
void uart0_init(void)	//19200bps
{
//ͨ÷ 51Ƭ UART 0 ʼ
    SCON  = 0x50;               // Mode 1: 8-bit UART, 
    TMOD |= 0x20;               // ʱ1 Mode 2: 8-Bit reload
    PCON  = 0x80;               // SMOD = 1
    TH1   = 256 - (uchar)(gCLK/192.0F/UART_BAUD);
    TR1   = 1;                  // ʱ 1 
    ES    = 1;                  // ж
}

void uart0_init_1200bps(void)
{
//ͨ÷ 51Ƭ UART 0 ʼ
    SCON  = 0x50;               // Mode 1: 8-bit UART, 
    TMOD |= 0x20;               // ʱ1 Mode 2: 8-Bit reload
    PCON  = 0x80;               // SMOD = 1
    TH1   = 256 - (uchar)(gCLK/192.0F/UART_BAUD_1200);
    TR1   = 1;                  // ʱ 1 
    ES    = 1;                  // ж
}


void Clear_Disp(void)
{
	 SendData(0xfd);	
  	 SendData(0x02);
  	 SendData(0x00);	
  	 SendData(0x00);
  	 send_stop_word();
}	

/******************************************/
void matrix_disp(uchar matrix_type,uint matrix_x,uint matrix_y,uint matrix_w,uint matrix_h)
{
	SendDataToLCD(0x27,0,0);
	SendData(matrix_type);
	SendData(matrix_x>>8);
	SendData(matrix_x);
	SendData(matrix_y>>8);
	SendData(matrix_y);
	
	SendData(matrix_w>>8);
	SendData(matrix_w);
	SendData(matrix_h>>8);
	SendData(matrix_h);
	send_stop_word();
}

/************************************/
void disp_round(uchar Mode,uint x0,uchar y0,uchar k)
{
	uchar r;
	SendDataToLCD(0x26,0,0);
	//for(r=0;r<255;r=r+k)
	//{
		SendData(Mode);
		SendData(x0>>8);
		SendData(x0);
		SendData(y0>>8);
		SendData(y0);
		SendData(k);
	//}
	send_stop_word();		
}
void send_stop_word(void)
{
	SendData(0xDD);	
	SendData(0xCC);	
	SendData(0xBB);	
	SendData(0xAA);	
}

void RealTimeDispPicFun(uchar Xaddr,uchar Yaddr,uchar Width,uchar Hight,uchar *Point)
{
	uint i;
	uint Count;
	SendDataToLCD(0x34,0,8);
	SendData(Xaddr>>8);
	SendData(Xaddr);
	SendData(Yaddr>>8);
	SendData(Yaddr);
	SendData(Width>>8);
	SendData(Width);
	SendData(Hight>>8);
	SendData(Hight);
	Count=(uint)Width*(uint)Hight/8;
	send_stop_word();
	//Delay_Nms(500);
	for(i=0;i<Count;i++)
	{	
		SendData(*Point);
		Point++;
	}
}

void ReceiveInt(void) interrupt 4	using	1
{
	if(RI)
	{
  		RevTab[count]=SBUF;
  		RI=0;
  		count++;
  	}
  	/*
  	if(TI)
  	{
		TI=0;	
  	}
  	*/
}

void HandShave(void)
{
	uchar *pp;
	char tab[10];
	//EA=1;
	RI=0;
	//count=0;
	SendDataToLCD(0x00,0,0x00);	
	send_stop_word();
	
	RevTab[0]=USART_Receive();
	RevTab[1]=USART_Receive();
	//while(count!=2);

	PutString(0,0,0x12,"ģ汾:V");
	count=0;
	tab[0]=(RevTab[0]>>4)+0x30;
	tab[1]='.';
	tab[2]=(RevTab[0]&0x0f)+0x30;
	tab[3]='\0';
	PutString(16,16,0x12,tab);
	
	Delay_Nms(1000);
	Delay_Nms(1000);
	Clear_Disp();	
	
	PutString(0,0,0x12,"Ŀǰʣ");
	switch(RevTab[1])
	{
		case 0:	PutString(88,16,0x12,"1200");
		break;
		case 1:	PutString(88,16,0x12,"2400");
		break;
		case 2:	PutString(88,16,0x12,"4800");
		break;
		case 3:	PutString(88,16,0x12,"9600");
		break;
		case 4:	PutString(88,16,0x12,"14400");
		break;		
		case 5:	PutString(88,16,0x12,"19200");
		break;
		case 6:PutString(88,16,0x12,"38400");
		break;
		case 7:	PutString(88,16,0x12,"56000");
		break;
		case 8:	PutString(88,16,0x12,"57600");
		break;
		case 0xff:PutString(88,16,0x12,"115200");
		break;	
		default:
		break;	
	}
	//EA=0;
}

void BackLight(uchar Type)
{
	SendDataToLCD(Type,0,0);
	send_stop_word();

}

void DrawLine(void)
{
	SendDataToLCD(0x23,0,0x00);
	SendData(1);
	
	SendData(0);
	SendData(0);
	SendData(0);
	SendData(16/2);
	
	SendData(0);
	SendData(24/2);
	SendData(0);
	SendData(24/2);
	
	SendData(0);
	SendData(48/2);
	SendData(0x00);
	SendData(48/2);
	
	SendData(0);
	SendData(0);
	SendData(0);
	SendData(16/2);

	send_stop_word();
}
void SanJiaoXing(void)
{
	SendDataToLCD(0x28,0,0x00);
	SendData(0);
	
	SendData(0);
	SendData(12);
	SendData(0x00);
	SendData(12);
	
	SendData(0);
	SendData(50);
	SendData(0);
	SendData(0);
	
	SendData(0);
	SendData(90);
	SendData(0x00);
	SendData(20);
	
	SendData(1);
	
	SendData(0);
	SendData(20);
	SendData(0x00);
	SendData(60);
	
	SendData(0);
	SendData(40);
	SendData(0x00);
	SendData(20);
	
	SendData(0);
	SendData(90);
	SendData(0x00);
	SendData(18);
	send_stop_word();
	
}
void DraWellipse(void)
{
	SendDataToLCD(0x29,0,0x00);
	SendData(0);
	
	SendData(0);
	SendData(30/2);
	SendData(0x00);
	SendData(32/2);
	
	SendData(0);
	SendData(30/2);
	SendData(0x00);
	SendData(20/2);
	
	SendData(1);	
	
	SendData(0);
	SendData(90/2);
	SendData(0x00);
	SendData(32/2);

	SendData(0);
	SendData(30/2);
	SendData(0x00);
	SendData(15/2);
	send_stop_word();	
}




/**************************/
void main (void)
{	
	Delay_Nms(100);
	uart0_init();
	Delay_Nms(100);	
	

	while(1)
	{
		Clear_Disp();
		HandShave();
		Delay_Nms(1000);	
		BackLight(0x09);
		Delay_Nms(1000);	
		BackLight(0x0a);
		Clear_Disp();
		
		Display_Chn(chn,0x12,10);
		Delay_Nms(1000);
		Delay_Nms(1000);
		Clear_Disp();
		Display_Chn(&chn[10],0x12,10);
		Delay_Nms(1000);
		Delay_Nms(1000);
		Clear_Disp();
		
		Display_Chn(chn,0x14,3);
		Delay_Nms(1000);	
		Delay_Nms(1000);	
	//	Display_bit();
	//	Delay_Nms(1000);
		Clear_Disp();
		Display_Chn(&chn[3],0x14,3);
		Delay_Nms(1000);	
		Delay_Nms(1000);	
	//	Display_bit();
	//	Delay_Nms(1000);
		Clear_Disp();

		disp_round(0,30/2,30/2,25/2);
		disp_round(1,110/2,15/2,10/2);
		DrawLine();
		matrix_disp(0,20/2,48/2,50/2,60/2);
		matrix_disp(1,80/2,20/2,110/2,60/2);
		//SanJiaoXing();
		Delay_Nms(1000);
		Clear_Disp();
		DraWellipse();
		Delay_Nms(1000);

		RealTimeDispPicFun(0,0,128,64/2,pic);	//ʾһͼƬ
		Delay_Nms(1000);
		RealTimeDispPicFun(0,0,128,64/2,&pic[128/8*32]);//ʾڶͼƬ
		Delay_Nms(1000);
    }
}
